package nl.niels.lostadventure;

import org.newdawn.slick.Color;
import org.newdawn.slick.Image;

public class Block {
    public static Block AIR = new Block(0,false,false);
    public static Block STONE = new Block(1,true,true,Img.getBlock(1));
    public static Block DIRT = new Block(2,true,true,Img.getBlock(2));
    public static Block GRASS = new Block(3,true,true,Img.getBlock(3));
    public static Block HARDSTONE = new Block(4,true,false,Img.getBlock(4));

    public int blockid;
    public boolean blocksolid;
    public boolean breakable;
    public Image blockimage;
    public Color blockcolor;

    public Block(int i, boolean j, boolean k) {
        blockid = i;
        blocksolid = j;
        breakable = k;
    }

    public Block(int i, boolean j, boolean k, Color l) {
        blockid = i;
        blocksolid = j;
        breakable = k;
        blockcolor = l;
    }

    public Block(int i, boolean j, boolean k,Image l) {
        blockid = i;
        blocksolid = j;
        breakable = k;
        blockimage = l;
    }

    public int getId() {
        return blockid;
    }
    
    public boolean isBreakable() {
        return breakable;
    }

    public boolean isSolid() {
        return blocksolid;
    }
}
