package nl.niels.lostadventure;

import java.awt.Font;
import java.util.Timer;
import java.util.TimerTask;
import org.lwjgl.input.Mouse;
import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Input;
import org.newdawn.slick.TrueTypeFont;

public class Client {
    private boolean online;
    private Player player;
    private Chat chat;
    private World currentworld;
    private World[] world = new World[128];
    public static TrueTypeFont font;
    private String error = "";
    private boolean showerror = false;
    
    private int bx;
    private int by;
    private boolean timeron = false;
    
    public Client() {
        //Main world init
        this.world[0] = new World(0, "NORMAL", 128, 256, this);
        this.world[0].setBackground(new Color(0.6F,0.9F,0.95F));
        currentworld = world[0];
        
        //Player init
        this.player = new Player("Player", world[0]);
        this.online = false;
        
        //Chat init
        Font awtFont = new Font("Times New Roman", Font.BOLD, 12);
        font = new TrueTypeFont(awtFont, false);
        chat = new Chat(5,8,LostAdventure.screenheight-96,font,player);
        chat.addLine("Welcome to Lost Adventure " + LostAdventure.version, Color.red, false, true);
    }
    
    int playerspeed = 1;
    Timer timer = new Timer();
    public void update(Input input) {
        if(!showerror) {
            currentworld.updateOnPlayer(player);
            player.checkPhysics(input);
            
            if(input.isMousePressed(1)) {
                int mx = (int) ((-currentworld.drawx+Mouse.getX())/16);
                int my = (int) ((-currentworld.drawy+(LostAdventure.screenheight-Mouse.getY()))/16);//((-currentworld.drawy+Mouse.getY())/16);
                if(currentworld.checkPosition(mx, my) == Block.AIR) {
                    currentworld.setBlock(mx, my, Block.STONE);
                }
            }
            else if(input.isMouseButtonDown(0)) {
                int mx = (int) ((-currentworld.drawx+Mouse.getX())/16);
                int my = (int) ((-currentworld.drawy+(LostAdventure.screenheight-Mouse.getY()))/16);//((-currentworld.drawy+Mouse.getY())/16);
                /*if(timeron) {
                    if(bx != mx || by != my) {
                        timer.cancel();
                        timeron = false;
                    }
                } else {
                    timeron = true;
                    bx = mx;
                    by = my;
                    timer.schedule(new TimerTask() {
                        @Override
                        public void run() {
                            timeron = false;
                            */if(currentworld.checkPosition(mx, my).isBreakable()) { currentworld.setBlock(mx, my, Block.AIR); }/*
                        }
                    }, 5*1000);
                }*/
            }/* else {
                if(timeron) {
                    timer.cancel();
                    timeron = false;
                }
            }*/
        }
    }
    
    public void draw(Graphics g, GameContainer gc) {
        if(!showerror) {
            currentworld.draw(g,gc);
            player.draw(g);
            chat.draw(g);
        } else {
            font.drawString((LostAdventure.screenwidth/2)-(font.getWidth(error)/2),(LostAdventure.screenheight/2)-(font.getHeight(error)/2),error);
        }
    }
    
    public boolean isOnline() {
        return online;
    }
    
    public void setErrorMsg(String error) {
        this.error = error;
    }
    
    public String getErrorMsg() {
        return error;
    }
    
    public void setError(boolean showerror) {
        this.showerror = showerror;
        if(showerror) {
            System.out.println(error);
        }
    }
    
    public boolean getError() {
        return showerror;
    }
    
    public Player getPlayer() {
        return player;
    }
    
    public Chat getChat() {
        return chat;
    }
}
