package nl.niels.lostadventure;

public class Location {
    private World world;
    private float x;
    private float y;

    public Location(World world, float i, float j) {
        x = i;
        y = j;
    }
    
    public World getWorld() {
        return world;
    }
    
    public void setX(float x) {
        this.x = x;
    }
    
    public void setY(float y) {
        this.y = y;
    }
    
    public float getX() {
        return x;
    }

    public float getY() {
        return y;
    }

    public Block getBlock() {
        return world.checkPosition((int) x, (int) y);
    }

    public Block getTop() {
        if(x < world.getHeight()) {
                return world.checkPosition((int) x, (int) y-1);
        } else {
                return null;
        }
    }

    public Block getBottom() {
        if(x > 0) {
                return world.checkPosition((int) x, (int) y+1);
        } else {
                return null;
        }
    }

    public Block getLeft() {
        if(y > 0) {
                return world.checkPosition((int) x-1, (int) y);
        } else {
                return null;
        }
    }

    public Block getRight() {
        if(x < world.getWidth()) {
                return world.checkPosition((int) x+1, (int) y);
        } else {
                return null;
        }
    }
}
