package nl.niels.lostadventure;

import org.newdawn.slick.Color;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Input;

public class Player {
    private String name;
    private Location location;
    private World currentworld;

    public Player(String name, World i) {
        this.name = name;
        this.currentworld = i;
        int x = (LostAdventure.screenwidth/2)-320;
        int y = -(i.getHeight()*i.getBlocksize()/2)+(LostAdventure.screenheight/2)+22;
        this.location = new Location(currentworld,x,y);
        System.out.println("Selected player=" + this.name + " on position x=" + location.getX() + " y=" + location.getY());
    }

    public Player(String name, World i, Location location) {
        this.name = name;
        currentworld = i;
        this.location = location;
        System.out.println("Selected player=" + this.name + " on position x=" + location.getX() + " y=" + location.getY());
    }
    
    boolean goleft = true, goright = true;
    public void checkPhysics(Input input) {
        //DOWN
        Block a = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)-14))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)+22))/16);
        Block b = currentworld.checkPosition((int) (-currentworld.drawx+(LostAdventure.screenwidth/2))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)+22))/16);
        Block c = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)+13))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)+22))/16);
        
        //RIGHT
        Block d = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)+14))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)+21))/16);
        Block e = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)+14))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)+7))/16);
        Block f = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)+14))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)-7))/16);
        Block g = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)+14))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)-21))/16);
        
        //UP
        Block h = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)-14))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)-23))/16);
        Block i = currentworld.checkPosition((int) (-currentworld.drawx+(LostAdventure.screenwidth/2))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)-23))/16);
        Block j = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)+13))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)-23))/16);
        
        //LEFT
        Block k = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)-15))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)+21))/16);
        Block l = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)-15))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)+7))/16);
        Block m = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)-15))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)-7))/16);
        Block n = currentworld.checkPosition((int) (-currentworld.drawx+((LostAdventure.screenwidth/2)-15))/16,(int) (-currentworld.drawy+((LostAdventure.screenheight/2)-21))/16);
        
        if(a.equals(Block.AIR) && b.equals(Block.AIR) && c.equals(Block.AIR)) {
            this.setY(this.getY()-1);
        }
        if(d.equals(Block.AIR) && e.equals(Block.AIR) && f.equals(Block.AIR) && g.equals(Block.AIR)) {
            if(this.getX() <= -((currentworld.getWidth()*16)-386-28)) {
                goright = false;
            } else {
                goright = true;
            }
        } else {
            goright = false;
        }
        if(h.equals(Block.AIR) && i.equals(Block.AIR) && j.equals(Block.AIR)) {
            
        }
        if(k.equals(Block.AIR) && l.equals(Block.AIR) && m.equals(Block.AIR) && n.equals(Block.AIR)) {
            if(this.getX() >= 386) {
                goleft = false;
            } else {
                goleft = true;
            }
        } else {
            goleft = false;
        }
        
        if(input.isKeyDown(Input.KEY_W)) {
            this.setY(this.getY()+2);
        } else if(input.isKeyDown(Input.KEY_A) && goleft) {
            this.setX(this.getX()+1);
        } else if(input.isKeyDown(Input.KEY_D) && goright) {
            this.setX(this.getX()-1);
        }
    }

    public World getCurrentWorld() {
        return currentworld;
    }

    public void draw(Graphics g) {
        int dx = (LostAdventure.screenwidth/2)-14;
        int dy = (LostAdventure.screenheight/2)-22;
        g.setColor(Color.yellow);
        g.fillRect(dx, dy, 28, 44);
        g.setColor(Color.white);
        Client.font.drawString((LostAdventure.screenwidth/2)-(Client.font.getWidth(name)/2), dy-24, name);
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public float getX() {
        return location.getX();
    }

    public float getY() {
        return location.getY();
    }
    
    public void setX(float x) {
        location.setX(x);
    }
    
    public void setY(float y) {
        location.setY(y);
    }

    public Location getLocation() {
        return location;
    }
}