package nl.niels.lostadventure;

import java.util.Random;

public class WorldGenerator {
    private String type;
    private World world;
    private int width;
    private int height;
    private Random random;
    
    public WorldGenerator(String i, World j, int k, int l) {
        type = i;
        world = j;
        width = k;
        height = l;
        random = new Random(world.getSeed());
    }

    public int Generate() {
        System.out.println("Creating world with generator: " + type + " and seed: " + world.getSeed());
        switch (type) {
            //FLAT
            case "FLAT":
                for(int x=0; x<width; x++) {
                    for(int y=0; y<height; y++) {
                        if(y>=Math.round(height/2)) {
                            if(y==Math.round(height/2)) {
                                world.setBlock(x, y, Block.GRASS);
                            } else if(y>Math.round(height/2) && y<Math.round(height/2)+4) {
                                world.setBlock(x, y, Block.DIRT);
                            } else {
                                world.setBlock(x, y, Block.STONE);
                            }
                        } else {
                            world.setBlock(x, y, Block.AIR);
                        }
                    }
                }
                for(int i=0; i<width; i++) {
                    world.setBlock(i,height-1,Block.HARDSTONE);
                }
                return 1;
            //FLAT
                
            //NORMAL
            case "NORMAL":
                int blockheight = 0;
                int roughness = 5;
                for(int x=0; x<width; x++) {
                    int r = random.nextInt(roughness);
                    if(r == 1) {
                        if(blockheight+1 >= height-3) {} else {
                            blockheight++;
                        }
                    } else if(r == 2) {
                        if(blockheight+1 <= 3) {} else {
                            blockheight--;
                        }
                    }
                    if(x==0) {
                        blockheight = height/2;
                    }
                    for(int y=0; y<height; y++) {
                        if(y>=blockheight) {
                            if(y==blockheight) {
                                world.setBlock(x, y, Block.GRASS);
                            } else if(y>blockheight && y<blockheight+4) {
                                world.setBlock(x, y, Block.DIRT);
                            } else {
                                world.setBlock(x, y, Block.STONE);
                            }
                        } else {
                            world.setBlock(x, y, Block.AIR);
                        }
                    }
                }
                for(int i=0; i<width; i++) {
                    world.setBlock(i,height-1,Block.HARDSTONE);
                }
                return 1;
            //NORMAL
        }
        return 0;
    }
}
